package org.openxma.dsl.reference.dao;

import org.openxma.dsl.platform.dao.*;
import java.util.Collection;
import java.util.Date;
import org.openxma.dsl.reference.dao.SpTestDao;
import org.openxma.dsl.reference.dto.SpCustomerInputParameter;
import org.openxma.dsl.reference.dto.SpReportResultDto;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedCollection;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedStructure;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedStructures;
import org.openxma.dsl.reference.model.SpTest;

/**
 * Represents a Data Access Object, as defined in the
 * Core J2EE Pattern Catalog (see http://java.sun.com/blueprints/corej2eepatterns/Patterns/DataAccessObject.html),
 * to abstract and encapsulate all access to entity SpTestDao.
 * @see SpTestDao
 */
public interface SpTestDaoGen extends GenericDao<SpTest,Long>, EntityFactory<SpTest> {
	/**
	 * Query name constants
	 */
	/**
	 * Stored procedure name constants
	 */
	static final String SP_BASE_FUNCTION_CALL_WITH_PACKAGE_NAME = "spName";
	static final String SP_FUNCTION_CALL_WITH_IMPLICIT_STRING_TYPE_RETURN = "spName";
	static final String SP_FUNCTION_CALL_WITH_IMPLICIT_INT_TYPE_RETURN = "spName";
	static final String SP_FUNCTION_CALL_WITH_IMPLICIT_DATE_TYPE_RETURN = "spName";
	static final String SP_BASE_STORED_PROCEDURE_CALL_WITH_PACKAGE_NAME = "spName";
	static final String SP_NO_RETURN_TYPE_AND_NO_PARAMETER = "spName";
	static final String SP_INTEGER_RETURN_TYPE_NO_PARAMETER = "spName";
	static final String SP_NO_RETURN_TYPE_WITH_INTEGER_IN_PARAMETER = "spName";
	static final String SP_INT_RETURN_TYPE_WITH_INT_IN_PARAMETER = "spName";
	static final String SP_INT_RETURN_TYPE_WITH_ADDITIONAL_UNUSED_PARAMETER = "spName";
	static final String SP_INT_COLLECTION_RETURN_TYPE = "spName";
	static final String SP_CALL_STORED_PROCEDURE_WITH_INPUT_PARAMETER_MAPPING = "spName";
	static final String SP_STORED_PROCEDURE_CALL_WITH_COMPLEX_TYPE_INPUT_PARAMETER = "spName";
	static final String SP_STORED_PROCEDURE_CALL_WITH_COMPLEX_TYPE_INPUT_PARAMETER_ALIAS_NAMES = "spName";
	static final String SP_REPORT_RESULT_DTO_RETURN_TYPE = "spName";
	static final String SP_REPORT_RESULT_DTO_RETURN_TYPE_WITH_OUT_PARAM_NAME_MAPPING = "spName";
	static final String SP_REPORT_RESULT_DTO_RETURN_TYPE_WITH_ORDER_OIDS = "spName";
	static final String SP_REPORT_RESULT_WITH_NESTED_STRUCTURE = "spName";
	static final String SP_REPORT_RESULT_WITH_NESTED_STRUCTURES = "spName";
	static final String SP_REPORT_RESULT_WITH_NESTED_COLLECTION = "spName";
	/**
	 * Factory method to create an empty <code>SpTest</code> entity with an already assigned identifier.
	 * The advantage of this approach, coupled with the fact that we're using the id for equals,
	 * is that equality test's are immediately possible and therefore independent from the persistence state
	 * of the entity. This in contrast to other solutions where auto generated Keys are used
	 * which must wait until the object is persisted or differentiate between transient and managed states.
	 * @return a new (transient), empty <code>SpTest</code> entity with an already assigned identifier.
	 */
	SpTest create();
	/**
	 *
	 * @return the  instance, or <code>null</code> if not found
	 */
	void baseFunctionCallWithPackageName();
	/**
	 *
	 * @return the string instance, or <code>null</code> if not found
	 */
	String functionCallWithImplicitStringTypeReturn();
	/**
	 *
	 * @return the integer instance, or <code>null</code> if not found
	 */
	Integer functionCallWithImplicitIntTypeReturn();
	/**
	 *
	 * @return the date instance, or <code>null</code> if not found
	 */
	Date functionCallWithImplicitDateTypeReturn();
	/**
	 *
	 * @return the  instance, or <code>null</code> if not found
	 */
	void baseStoredProcedureCallWithPackageName();
	/**
	 *
	 * @return the  instance, or <code>null</code> if not found
	 */
	void noReturnTypeAndNoParameter();
	/**
	 *
	 * @return the integer instance, or <code>null</code> if not found
	 */
	Integer integerReturnTypeNoParameter();
	/**
	 *
	 * @param i1
	 * @return the  instance, or <code>null</code> if not found
	 */
	void noReturnTypeWithIntegerInParameter(Integer i1);
	/**
	 *
	 * @param i1
	 * @return the integer instance, or <code>null</code> if not found
	 */
	Integer intReturnTypeWithIntInParameter(Integer i1);
	/**
	 *
	 * @param i1
	 * @param otherParameter
	 * @return the integer instance, or <code>null</code> if not found
	 */
	Integer intReturnTypeWithAdditionalUnusedParameter(Integer i1,String otherParameter);
	/**
	 *
	 * @param i1
	 * @return a collection containing 0 or more persistent Integer instances
	 */
	Collection<Integer> intCollectionReturnType(Integer i1);
	/**
	 *
	 * @param customerOid
	 * @param fromDate
	 * @return the string instance, or <code>null</code> if not found
	 */
	String callStoredProcedureWithInputParameterMapping(Integer customerOid,Date fromDate);
	/**
	 *
	 * @param customerInput
	 * @return the  instance, or <code>null</code> if not found
	 */
	void storedProcedureCallWithComplexTypeInputParameter(SpCustomerInputParameter customerInput);
	/**
	 *
	 * @param customerInput
	 * @return the  instance, or <code>null</code> if not found
	 */
	void storedProcedureCallWithComplexTypeInputParameterAliasNames(SpCustomerInputParameter customerInput);
	/**
	 *
	 * @param customerOid
	 * @return the spReportResultDto instance, or <code>null</code> if not found
	 */
	SpReportResultDto reportResultDtoReturnType(Integer customerOid);
	/**
	 *
	 * @param customerOid
	 * @return the spReportResultDto instance, or <code>null</code> if not found
	 */
	SpReportResultDto reportResultDtoReturnTypeWithOutParamNameMapping(Integer customerOid);
	/**
	 *
	 * @param customerOid
	 * @return the spReportResultDto instance, or <code>null</code> if not found
	 */
	SpReportResultDto reportResultDtoReturnTypeWithOrderOids(Integer customerOid);
	/**
	 *
	 * @param customerOid
	 * @return the spResultDtoWithNestedStructure instance, or <code>null</code> if not found
	 */
	SpResultDtoWithNestedStructure reportResultWithNestedStructure(Integer customerOid);
	/**
	 *
	 * @param customerOid
	 * @return the spResultDtoWithNestedStructures instance, or <code>null</code> if not found
	 */
	SpResultDtoWithNestedStructures reportResultWithNestedStructures(Integer customerOid);
	/**
	 *
	 * @param customerOid
	 * @return the spResultDtoWithNestedCollection instance, or <code>null</code> if not found
	 */
	SpResultDtoWithNestedCollection reportResultWithNestedCollection(Integer customerOid);
}
