package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.openxma.dsl.platform.jdbc.JdbcUtils2;
import org.openxma.dsl.reference.dao.SpTestDao;
import org.openxma.dsl.reference.dto.SpCustomerInputParameter;
import org.openxma.dsl.reference.dto.SpOutCustomer;
import org.openxma.dsl.reference.dto.SpReportResultDto;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedCollection;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedStructure;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedStructures;
import org.openxma.dsl.reference.model.SpTest;
import org.openxma.dsl.reference.model.impl.SpTestImpl;
import org.springframework.jdbc.core.simple.ParameterizedRowMapper;
import org.springframework.jdbc.core.simple.SimpleJdbcCall;
/**
 * @see SpTestDao
 */
@SuppressWarnings("unused")
public abstract class SpTestDaoGenImpl extends GenericDaoHibernateImpl<SpTest,Long> implements SpTestDao {
	
	public SpTestDaoGenImpl() {
		super(SpTestImpl.class);
	}
	
	/**
	 * @param context the context for the object creation
	 * @return a transient instance of entity <code>SpTest</code> with an already assigned identifier.
	 */
	public SpTest createEntity(Object context) {
		return create();
	}
	
	public SpTest create() 
	{
		SpTest spTest = createEntityInstance();
		spTest.setOid(Long.valueOf(dataFieldMaxValueIncrementer.nextLongValue()));
		return spTest;
	}
	
	public void baseFunctionCallWithPackageName() {
		SimpleJdbcCall jdbcCall = prepareBaseFunctionCallWithPackageNameJdbcCall();
		Map<String, Object> _resultMap = executeBaseFunctionCallWithPackageName(jdbcCall);
	}
	
	protected SimpleJdbcCall prepareBaseFunctionCallWithPackageNameJdbcCall() {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_BASE_FUNCTION_CALL_WITH_PACKAGE_NAME,"PACKAGE");
		jdbcCall.setFunction(true);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeBaseFunctionCallWithPackageName(SimpleJdbcCall jdbcCall) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	public String functionCallWithImplicitStringTypeReturn() {
		SimpleJdbcCall jdbcCall = prepareFunctionCallWithImplicitStringTypeReturnJdbcCall();
		Map<String, Object> _resultMap = executeFunctionCallWithImplicitStringTypeReturn(jdbcCall);
		return mapFunctionCallWithImplicitStringTypeReturnResult(_resultMap);
	}
	
	protected SimpleJdbcCall prepareFunctionCallWithImplicitStringTypeReturnJdbcCall() {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_FUNCTION_CALL_WITH_IMPLICIT_STRING_TYPE_RETURN);
		jdbcCall.setFunction(true);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeFunctionCallWithImplicitStringTypeReturn(SimpleJdbcCall jdbcCall) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected String mapFunctionCallWithImplicitStringTypeReturnResult(Map<String, Object> _resultMap) {
		return (String) _resultMap.get("return");
	}
	
	public Integer functionCallWithImplicitIntTypeReturn() {
		SimpleJdbcCall jdbcCall = prepareFunctionCallWithImplicitIntTypeReturnJdbcCall();
		Map<String, Object> _resultMap = executeFunctionCallWithImplicitIntTypeReturn(jdbcCall);
		return mapFunctionCallWithImplicitIntTypeReturnResult(_resultMap);
	}
	
	protected SimpleJdbcCall prepareFunctionCallWithImplicitIntTypeReturnJdbcCall() {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_FUNCTION_CALL_WITH_IMPLICIT_INT_TYPE_RETURN);
		jdbcCall.setFunction(true);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeFunctionCallWithImplicitIntTypeReturn(SimpleJdbcCall jdbcCall) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected Integer mapFunctionCallWithImplicitIntTypeReturnResult(Map<String, Object> _resultMap) {
		return (Integer) _resultMap.get("return");
	}
	
	public Date functionCallWithImplicitDateTypeReturn() {
		SimpleJdbcCall jdbcCall = prepareFunctionCallWithImplicitDateTypeReturnJdbcCall();
		Map<String, Object> _resultMap = executeFunctionCallWithImplicitDateTypeReturn(jdbcCall);
		return mapFunctionCallWithImplicitDateTypeReturnResult(_resultMap);
	}
	
	protected SimpleJdbcCall prepareFunctionCallWithImplicitDateTypeReturnJdbcCall() {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_FUNCTION_CALL_WITH_IMPLICIT_DATE_TYPE_RETURN);
		jdbcCall.setFunction(true);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeFunctionCallWithImplicitDateTypeReturn(SimpleJdbcCall jdbcCall) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected Date mapFunctionCallWithImplicitDateTypeReturnResult(Map<String, Object> _resultMap) {
		return (Date) _resultMap.get("return");
	}
	
	public void baseStoredProcedureCallWithPackageName() {
		SimpleJdbcCall jdbcCall = prepareBaseStoredProcedureCallWithPackageNameJdbcCall();
		Map<String, Object> _resultMap = executeBaseStoredProcedureCallWithPackageName(jdbcCall);
	}
	
	protected SimpleJdbcCall prepareBaseStoredProcedureCallWithPackageNameJdbcCall() {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_BASE_STORED_PROCEDURE_CALL_WITH_PACKAGE_NAME,"PACKAGE");
		return jdbcCall;
	}
	
	protected Map<String, Object> executeBaseStoredProcedureCallWithPackageName(SimpleJdbcCall jdbcCall) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	public void noReturnTypeAndNoParameter() {
		SimpleJdbcCall jdbcCall = prepareNoReturnTypeAndNoParameterJdbcCall();
		Map<String, Object> _resultMap = executeNoReturnTypeAndNoParameter(jdbcCall);
	}
	
	protected SimpleJdbcCall prepareNoReturnTypeAndNoParameterJdbcCall() {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_NO_RETURN_TYPE_AND_NO_PARAMETER);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeNoReturnTypeAndNoParameter(SimpleJdbcCall jdbcCall) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	public Integer integerReturnTypeNoParameter() {
		SimpleJdbcCall jdbcCall = prepareIntegerReturnTypeNoParameterJdbcCall();
		Map<String, Object> _resultMap = executeIntegerReturnTypeNoParameter(jdbcCall);
		return mapIntegerReturnTypeNoParameterResult(_resultMap);
	}
	
	protected SimpleJdbcCall prepareIntegerReturnTypeNoParameterJdbcCall() {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_INTEGER_RETURN_TYPE_NO_PARAMETER);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeIntegerReturnTypeNoParameter(SimpleJdbcCall jdbcCall) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected Integer mapIntegerReturnTypeNoParameterResult(Map<String, Object> _resultMap) {
		return (Integer) _resultMap.get("integerReturnTypeNoParameter_return");
	}
	
	public void noReturnTypeWithIntegerInParameter(Integer i1) {
		SimpleJdbcCall jdbcCall = prepareNoReturnTypeWithIntegerInParameterJdbcCall(i1);
		Map<String, Object> _resultMap = executeNoReturnTypeWithIntegerInParameter(jdbcCall,i1);
	}
	
	protected SimpleJdbcCall prepareNoReturnTypeWithIntegerInParameterJdbcCall(Integer i1) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_NO_RETURN_TYPE_WITH_INTEGER_IN_PARAMETER);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeNoReturnTypeWithIntegerInParameter(SimpleJdbcCall jdbcCall,Integer i1) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("i1",i1);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	public Integer intReturnTypeWithIntInParameter(Integer i1) {
		SimpleJdbcCall jdbcCall = prepareIntReturnTypeWithIntInParameterJdbcCall(i1);
		Map<String, Object> _resultMap = executeIntReturnTypeWithIntInParameter(jdbcCall,i1);
		return mapIntReturnTypeWithIntInParameterResult(_resultMap,i1);
	}
	
	protected SimpleJdbcCall prepareIntReturnTypeWithIntInParameterJdbcCall(Integer i1) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_INT_RETURN_TYPE_WITH_INT_IN_PARAMETER);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeIntReturnTypeWithIntInParameter(SimpleJdbcCall jdbcCall,Integer i1) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("i1",i1);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected Integer mapIntReturnTypeWithIntInParameterResult(Map<String, Object> _resultMap,Integer i1) {
		return (Integer) _resultMap.get("intReturnTypeWithIntInParameter_return");
	}
	
	public Integer intReturnTypeWithAdditionalUnusedParameter(Integer i1,String otherParameter) {
		SimpleJdbcCall jdbcCall = prepareIntReturnTypeWithAdditionalUnusedParameterJdbcCall(i1,otherParameter);
		Map<String, Object> _resultMap = executeIntReturnTypeWithAdditionalUnusedParameter(jdbcCall,i1,otherParameter);
		return mapIntReturnTypeWithAdditionalUnusedParameterResult(_resultMap,i1,otherParameter);
	}
	
	protected SimpleJdbcCall prepareIntReturnTypeWithAdditionalUnusedParameterJdbcCall(Integer i1,String otherParameter) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_INT_RETURN_TYPE_WITH_ADDITIONAL_UNUSED_PARAMETER);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeIntReturnTypeWithAdditionalUnusedParameter(SimpleJdbcCall jdbcCall,Integer i1,String otherParameter) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("i1",i1);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected Integer mapIntReturnTypeWithAdditionalUnusedParameterResult(Map<String, Object> _resultMap,Integer i1,String otherParameter) {
		return (Integer) _resultMap.get("intReturnTypeWithAdditionalParameters_return");
	}
	
	public Collection<Integer> intCollectionReturnType(Integer i1) {
		SimpleJdbcCall jdbcCall = prepareIntCollectionReturnTypeJdbcCall(i1);
		Map<String, Object> _resultMap = executeIntCollectionReturnType(jdbcCall,i1);
		return mapIntCollectionReturnTypeResult(_resultMap,i1);
	}
	
	protected SimpleJdbcCall prepareIntCollectionReturnTypeJdbcCall(Integer i1) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_INT_COLLECTION_RETURN_TYPE);
		jdbcCall.addDeclaredRowMapper("_resultSet", new ParameterizedRowMapper<Integer>() {
			public Integer mapRow(ResultSet rs, int rowNum) throws SQLException {
				return JdbcUtils2.getResultSetValue(rs,"CUSTOMER_OID",Integer.class);
			}
		});
		return jdbcCall;
	}
	
	protected Map<String, Object> executeIntCollectionReturnType(SimpleJdbcCall jdbcCall,Integer i1) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("i1",i1);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected Collection<Integer> mapIntCollectionReturnTypeResult(Map<String, Object> _resultMap,Integer i1) {
		@SuppressWarnings("unchecked")
		Collection<Integer> _resultSet = (Collection<Integer>) _resultMap.get("_resultSet");
		return _resultSet;
	}
	
	public String callStoredProcedureWithInputParameterMapping(Integer customerOid,Date fromDate) {
		SimpleJdbcCall jdbcCall = prepareCallStoredProcedureWithInputParameterMappingJdbcCall(customerOid,fromDate);
		Map<String, Object> _resultMap = executeCallStoredProcedureWithInputParameterMapping(jdbcCall,customerOid,fromDate);
		return mapCallStoredProcedureWithInputParameterMappingResult(_resultMap,customerOid,fromDate);
	}
	
	protected SimpleJdbcCall prepareCallStoredProcedureWithInputParameterMappingJdbcCall(Integer customerOid,Date fromDate) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_CALL_STORED_PROCEDURE_WITH_INPUT_PARAMETER_MAPPING);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeCallStoredProcedureWithInputParameterMapping(SimpleJdbcCall jdbcCall,Integer customerOid,Date fromDate) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("IN_CUSTOMER_OID",customerOid);
		parametersMap.put("IN_FROM_DATE",fromDate);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected String mapCallStoredProcedureWithInputParameterMappingResult(Map<String, Object> _resultMap,Integer customerOid,Date fromDate) {
		return (String) _resultMap.get("OUT_RESULT");
	}
	
	public void storedProcedureCallWithComplexTypeInputParameter(SpCustomerInputParameter customerInput) {
		SimpleJdbcCall jdbcCall = prepareStoredProcedureCallWithComplexTypeInputParameterJdbcCall(customerInput);
		Map<String, Object> _resultMap = executeStoredProcedureCallWithComplexTypeInputParameter(jdbcCall,customerInput);
	}
	
	protected SimpleJdbcCall prepareStoredProcedureCallWithComplexTypeInputParameterJdbcCall(SpCustomerInputParameter customerInput) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_STORED_PROCEDURE_CALL_WITH_COMPLEX_TYPE_INPUT_PARAMETER);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeStoredProcedureCallWithComplexTypeInputParameter(SimpleJdbcCall jdbcCall,SpCustomerInputParameter customerInput) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("customerOid",customerInput==null ? null:customerInput.getCustomerOid());
		parametersMap.put("firstName",customerInput==null ? null:customerInput.getFirstName());
		parametersMap.put("lastName",customerInput==null ? null:customerInput.getLastName());
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	public void storedProcedureCallWithComplexTypeInputParameterAliasNames(SpCustomerInputParameter customerInput) {
		SimpleJdbcCall jdbcCall = prepareStoredProcedureCallWithComplexTypeInputParameterAliasNamesJdbcCall(customerInput);
		Map<String, Object> _resultMap = executeStoredProcedureCallWithComplexTypeInputParameterAliasNames(jdbcCall,customerInput);
	}
	
	protected SimpleJdbcCall prepareStoredProcedureCallWithComplexTypeInputParameterAliasNamesJdbcCall(SpCustomerInputParameter customerInput) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_STORED_PROCEDURE_CALL_WITH_COMPLEX_TYPE_INPUT_PARAMETER_ALIAS_NAMES);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeStoredProcedureCallWithComplexTypeInputParameterAliasNames(SimpleJdbcCall jdbcCall,SpCustomerInputParameter customerInput) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("IN_CUSTOMER_OID",customerInput==null ? null:customerInput.getCustomerOid());
		parametersMap.put("IN_CUSTOMER_FIRST_NAME",customerInput==null ? null:customerInput.getFirstName());
		parametersMap.put("IN_CUSTOMER_LAST_NAME",customerInput==null ? null:customerInput.getLastName());
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	public SpReportResultDto reportResultDtoReturnType(Integer customerOid) {
		SimpleJdbcCall jdbcCall = prepareReportResultDtoReturnTypeJdbcCall(customerOid);
		Map<String, Object> _resultMap = executeReportResultDtoReturnType(jdbcCall,customerOid);
		return mapReportResultDtoReturnTypeResult(_resultMap,customerOid);
	}
	
	protected SimpleJdbcCall prepareReportResultDtoReturnTypeJdbcCall(Integer customerOid) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_REPORT_RESULT_DTO_RETURN_TYPE);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeReportResultDtoReturnType(SimpleJdbcCall jdbcCall,Integer customerOid) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("customerOid",customerOid);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected SpReportResultDto mapReportResultDtoReturnTypeResult(Map<String, Object> _resultMap,Integer customerOid) {
		SpReportResultDto _spReportResultDto = new SpReportResultDto();
		_spReportResultDto.setCountRows((Integer)_resultMap.get("countRows"));
		_spReportResultDto.setCustomerName((String)_resultMap.get("customerName"));
		return _spReportResultDto;
	}
	
	public SpReportResultDto reportResultDtoReturnTypeWithOutParamNameMapping(Integer customerOid) {
		SimpleJdbcCall jdbcCall = prepareReportResultDtoReturnTypeWithOutParamNameMappingJdbcCall(customerOid);
		Map<String, Object> _resultMap = executeReportResultDtoReturnTypeWithOutParamNameMapping(jdbcCall,customerOid);
		return mapReportResultDtoReturnTypeWithOutParamNameMappingResult(_resultMap,customerOid);
	}
	
	protected SimpleJdbcCall prepareReportResultDtoReturnTypeWithOutParamNameMappingJdbcCall(Integer customerOid) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_REPORT_RESULT_DTO_RETURN_TYPE_WITH_OUT_PARAM_NAME_MAPPING);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeReportResultDtoReturnTypeWithOutParamNameMapping(SimpleJdbcCall jdbcCall,Integer customerOid) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("customerOid",customerOid);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected SpReportResultDto mapReportResultDtoReturnTypeWithOutParamNameMappingResult(Map<String, Object> _resultMap,Integer customerOid) {
		SpReportResultDto _spReportResultDto = new SpReportResultDto();
		_spReportResultDto.setCountRows((Integer)_resultMap.get("OUT_COUNT_ROWS"));
		_spReportResultDto.setCustomerName((String)_resultMap.get("OUT_CUSTOMER_NAME"));
		return _spReportResultDto;
	}
	
	public SpReportResultDto reportResultDtoReturnTypeWithOrderOids(Integer customerOid) {
		SimpleJdbcCall jdbcCall = prepareReportResultDtoReturnTypeWithOrderOidsJdbcCall(customerOid);
		Map<String, Object> _resultMap = executeReportResultDtoReturnTypeWithOrderOids(jdbcCall,customerOid);
		return mapReportResultDtoReturnTypeWithOrderOidsResult(_resultMap,customerOid);
	}
	
	protected SimpleJdbcCall prepareReportResultDtoReturnTypeWithOrderOidsJdbcCall(Integer customerOid) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_REPORT_RESULT_DTO_RETURN_TYPE_WITH_ORDER_OIDS);
		jdbcCall.addDeclaredRowMapper("_orderIds_resultSet", new ParameterizedRowMapper<Integer>() {
			public Integer mapRow(ResultSet rs, int rowNum) throws SQLException {
				return JdbcUtils2.getResultSetValue(rs,"orderIds",Integer.class);
			}
		});
		return jdbcCall;
	}
	
	protected Map<String, Object> executeReportResultDtoReturnTypeWithOrderOids(SimpleJdbcCall jdbcCall,Integer customerOid) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("customerOid",customerOid);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected SpReportResultDto mapReportResultDtoReturnTypeWithOrderOidsResult(Map<String, Object> _resultMap,Integer customerOid) {
		SpReportResultDto _spReportResultDto = new SpReportResultDto();
		_spReportResultDto.setCountRows((Integer)_resultMap.get("countRows"));
		_spReportResultDto.setCustomerName((String)_resultMap.get("customerName"));
		@SuppressWarnings("unchecked")
		List<Integer> _orderIdsResultSet = (List<Integer>) _resultMap.get("_orderIds_resultSet");
		_spReportResultDto.setOrderIds(_orderIdsResultSet);
		return _spReportResultDto;
	}
	
	public SpResultDtoWithNestedStructure reportResultWithNestedStructure(Integer customerOid) {
		SimpleJdbcCall jdbcCall = prepareReportResultWithNestedStructureJdbcCall(customerOid);
		Map<String, Object> _resultMap = executeReportResultWithNestedStructure(jdbcCall,customerOid);
		return mapReportResultWithNestedStructureResult(_resultMap,customerOid);
	}
	
	protected SimpleJdbcCall prepareReportResultWithNestedStructureJdbcCall(Integer customerOid) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_REPORT_RESULT_WITH_NESTED_STRUCTURE);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeReportResultWithNestedStructure(SimpleJdbcCall jdbcCall,Integer customerOid) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("customerOid",customerOid);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected SpResultDtoWithNestedStructure mapReportResultWithNestedStructureResult(Map<String, Object> _resultMap,Integer customerOid) {
		SpResultDtoWithNestedStructure _spResultDtoWithNestedStructure = new SpResultDtoWithNestedStructure();
		_spResultDtoWithNestedStructure.setCountRows((Integer)_resultMap.get("countRows"));
		SpOutCustomer _customer = new SpOutCustomer();
		_spResultDtoWithNestedStructure.setCustomer(_customer);
		_customer.setCustomerOid((Long)_resultMap.get("OUT_CUSTOMER_OID"));
		_customer.setFirstName((String)_resultMap.get("OUT_CUSTOMER_FIRST_NAME"));
		_customer.setLastName((String)_resultMap.get("OUT_CUSTOMER_LAST_NAME"));
		_customer.setBirthDate((Date)_resultMap.get("OUT_CUSTOMER_BIRTH_DATE"));
		return _spResultDtoWithNestedStructure;
	}
	
	public SpResultDtoWithNestedStructures reportResultWithNestedStructures(Integer customerOid) {
		SimpleJdbcCall jdbcCall = prepareReportResultWithNestedStructuresJdbcCall(customerOid);
		Map<String, Object> _resultMap = executeReportResultWithNestedStructures(jdbcCall,customerOid);
		return mapReportResultWithNestedStructuresResult(_resultMap,customerOid);
	}
	
	protected SimpleJdbcCall prepareReportResultWithNestedStructuresJdbcCall(Integer customerOid) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_REPORT_RESULT_WITH_NESTED_STRUCTURES);
		return jdbcCall;
	}
	
	protected Map<String, Object> executeReportResultWithNestedStructures(SimpleJdbcCall jdbcCall,Integer customerOid) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("customerOid",customerOid);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected SpResultDtoWithNestedStructures mapReportResultWithNestedStructuresResult(Map<String, Object> _resultMap,Integer customerOid) {
		SpResultDtoWithNestedStructures _spResultDtoWithNestedStructures = new SpResultDtoWithNestedStructures();
		_spResultDtoWithNestedStructures.setCountRows((Integer)_resultMap.get("countRows"));
		SpOutCustomer _customer1 = new SpOutCustomer();
		_spResultDtoWithNestedStructures.setCustomer1(_customer1);
		_customer1.setCustomerOid((Long)_resultMap.get("OUT_CUSTOMER_OID"));
		_customer1.setFirstName((String)_resultMap.get("OUT_CUSTOMER_FIRST_NAME"));
		SpOutCustomer _customer2 = new SpOutCustomer();
		_spResultDtoWithNestedStructures.setCustomer2(_customer2);
		_customer2.setLastName((String)_resultMap.get("OUT_CUSTOMER_LAST_NAME"));
		_customer2.setBirthDate((Date)_resultMap.get("OUT_CUSTOMER_BIRTH_DATE"));
		return _spResultDtoWithNestedStructures;
	}
	
	public SpResultDtoWithNestedCollection reportResultWithNestedCollection(Integer customerOid) {
		SimpleJdbcCall jdbcCall = prepareReportResultWithNestedCollectionJdbcCall(customerOid);
		Map<String, Object> _resultMap = executeReportResultWithNestedCollection(jdbcCall,customerOid);
		return mapReportResultWithNestedCollectionResult(_resultMap,customerOid);
	}
	
	protected SimpleJdbcCall prepareReportResultWithNestedCollectionJdbcCall(Integer customerOid) {
		SimpleJdbcCall jdbcCall = createJdbcCall(SP_REPORT_RESULT_WITH_NESTED_COLLECTION);
		jdbcCall.addDeclaredRowMapper("_customers_resultSet", new ParameterizedRowMapper<SpOutCustomer>() {
			public SpOutCustomer mapRow(ResultSet rs, int rowNum) throws SQLException {
				SpOutCustomer _customers = new SpOutCustomer();	   
				_customers.setCustomerOid(JdbcUtils2.getResultSetValue(rs,"OUT_CUSTOMER_OID",Long.class));	 
				_customers.setFirstName(JdbcUtils2.getResultSetValue(rs,"OUT_CUSTOMER_FIRST_NAME",String.class));	 
				_customers.setLastName(JdbcUtils2.getResultSetValue(rs,"OUT_CUSTOMER_LAST_NAME",String.class));	 
				_customers.setBirthDate(JdbcUtils2.getResultSetValue(rs,"OUT_CUSTOMER_BIRTH_DATE",Date.class));	 
				return _customers;
			}
		});
		return jdbcCall;
	}
	
	protected Map<String, Object> executeReportResultWithNestedCollection(SimpleJdbcCall jdbcCall,Integer customerOid) {
		Map<String,Object> parametersMap = new HashMap<String,Object>();
		parametersMap.put("customerOid",customerOid);
		return executeJdbcCall(jdbcCall,parametersMap);
	}
	
	protected SpResultDtoWithNestedCollection mapReportResultWithNestedCollectionResult(Map<String, Object> _resultMap,Integer customerOid) {
		SpResultDtoWithNestedCollection _spResultDtoWithNestedCollection = new SpResultDtoWithNestedCollection();
		_spResultDtoWithNestedCollection.setCountRows((Integer)_resultMap.get("countRows"));
		@SuppressWarnings("unchecked")
		List<SpOutCustomer> _customersResultSet = (List<SpOutCustomer>) _resultMap.get("_customers_resultSet");
		_spResultDtoWithNestedCollection.setCustomers(_customersResultSet);
		return _spResultDtoWithNestedCollection;
	}
	
	protected Mapper getNamedQueryMapper(String queryName) {
		return new SpTestDaoQueryMapper();
	}
	
	protected class SpTestDaoQueryMapper extends NamedQueryMapper {
		
	@SuppressWarnings("unchecked")
	public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
		return super.mapOne(sourceObject, targetObject);
	}
}
}
