package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.openxma.dsl.reference.dto.AddressView;
import org.openxma.dsl.reference.dto.OrderView;
import org.openxma.dsl.reference.types.Gender;
import org.openxma.dsl.reference.types.valueobject.TelefonNumber;

public abstract class CustomerViewGen implements Serializable {
	private static final long serialVersionUID = -686128378;
	protected String city;
	protected String country;
	protected String streetName;
	protected List<OrderView> orders;
	protected AddressView invoiceAddress;
	protected AddressView deliveryAddress;
	protected String oid;
	protected Date version;
	protected String firstName;
	protected String lastName;
	protected Gender gender;
	protected String emailAddress;
	protected Date birthDate;
	protected TelefonNumber telefonNumber;
	protected Date lastOrderDate;
	protected String invoiceAddressOid;
	protected String deliveryAddressOid;
	
	public String getCity() {
		return this.city;
	}
	
	public void setCity(String city) {
		this.city=city;
	}
	
	public String getCountry() {
		return this.country;
	}
	
	public void setCountry(String country) {
		this.country=country;
	}
	
	public String getStreetName() {
		return this.streetName;
	}
	
	public void setStreetName(String streetName) {
		this.streetName=streetName;
	}
	
	public List<OrderView> getOrders() {
		return this.orders;
	}
	
	public void setOrders(List<OrderView> orders) {
		this.orders=orders;
	}
	
	public void addOrders(OrderView orders) {
		if (orders == null) {
			throw new IllegalArgumentException("parameter 'orders' must not be null");
		}
		if (getOrders() == null) {
			this.orders = new ArrayList<OrderView>();
		}
		this.orders.add(orders);
	}
	
	public AddressView getInvoiceAddress() {
		return this.invoiceAddress;
	}
	
	public void setInvoiceAddress(AddressView invoiceAddress) {
		this.invoiceAddress=invoiceAddress;
	}
	
	public AddressView getDeliveryAddress() {
		return this.deliveryAddress;
	}
	
	public void setDeliveryAddress(AddressView deliveryAddress) {
		this.deliveryAddress=deliveryAddress;
	}
	
	public String getOid() {
		return this.oid;
	}
	
	public void setOid(String oid) {
		this.oid=oid;
	}
	
	public Date getVersion() {
		return this.version;
	}
	
	public void setVersion(Date version) {
		this.version=version;
	}
	
	public String getFirstName() {
		return this.firstName;
	}
	
	public void setFirstName(String firstName) {
		this.firstName=firstName;
	}
	
	public String getLastName() {
		return this.lastName;
	}
	
	public void setLastName(String lastName) {
		this.lastName=lastName;
	}
	
	public Gender getGender() {
		return this.gender;
	}
	
	public void setGender(Gender gender) {
		this.gender=gender;
	}
	
	public String getEmailAddress() {
		return this.emailAddress;
	}
	
	public void setEmailAddress(String emailAddress) {
		this.emailAddress=emailAddress;
	}
	
	public Date getBirthDate() {
		return this.birthDate;
	}
	
	public void setBirthDate(Date birthDate) {
		this.birthDate=birthDate;
	}
	
	public TelefonNumber getTelefonNumber() {
		return this.telefonNumber;
	}
	
	public void setTelefonNumber(TelefonNumber telefonNumber) {
		this.telefonNumber=telefonNumber;
	}
	
	public Date getLastOrderDate() {
		return this.lastOrderDate;
	}
	
	public void setLastOrderDate(Date lastOrderDate) {
		this.lastOrderDate=lastOrderDate;
	}
	
	public String getInvoiceAddressOid() {
		return this.invoiceAddressOid;
	}
	
	public void setInvoiceAddressOid(String invoiceAddressOid) {
		this.invoiceAddressOid=invoiceAddressOid;
	}
	
	public String getDeliveryAddressOid() {
		return this.deliveryAddressOid;
	}
	
	public void setDeliveryAddressOid(String deliveryAddressOid) {
		this.deliveryAddressOid=deliveryAddressOid;
	}
	
	
	@Override
	public String toString() {
		StringBuilder toStringBuilder = new StringBuilder("CustomerView [");
		toStringBuilder.append("city=").append(getCity()).append(",");
		toStringBuilder.append("country=").append(getCountry()).append(",");
		toStringBuilder.append("streetName=").append(getStreetName()).append(",");
		toStringBuilder.append("oid=").append(getOid()).append(",");
		toStringBuilder.append("version=").append(getVersion()).append(",");
		toStringBuilder.append("firstName=").append(getFirstName()).append(",");
		toStringBuilder.append("lastName=").append(getLastName()).append(",");
		toStringBuilder.append("gender=").append(getGender()).append(",");
		toStringBuilder.append("emailAddress=").append(getEmailAddress()).append(",");
		toStringBuilder.append("birthDate=").append(getBirthDate()).append(",");
		toStringBuilder.append("telefonNumber=").append(getTelefonNumber()).append(",");
		toStringBuilder.append("lastOrderDate=").append(getLastOrderDate()).append(",");
		toStringBuilder.append("invoiceAddressOid=").append(getInvoiceAddressOid()).append(",");
		toStringBuilder.append("deliveryAddressOid=").append(getDeliveryAddressOid());
		return toStringBuilder.append("]").toString();
	}
}
