package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.openxma.dsl.reference.dto.CustomerOrderView;
import org.openxma.dsl.reference.dto.OrderItemQuantityView;
import org.openxma.dsl.reference.types.valueobject.OrderNumber;

public abstract class OrderStateViewGen implements Serializable {
	private static final long serialVersionUID = 1570511469;
	protected Long maxOrderItemCount;
	protected String oid;
	protected OrderNumber orderNumber;
	protected Date deliveryDate;
	protected String storeId;
	protected Date placementDate;
	protected String orderState;
	protected CustomerOrderView customer;
	protected List<OrderItemQuantityView> orderItems;
	
	public Long getMaxOrderItemCount() {
		return this.maxOrderItemCount;
	}
	
	public void setMaxOrderItemCount(Long maxOrderItemCount) {
		this.maxOrderItemCount=maxOrderItemCount;
	}
	
	public String getOid() {
		return this.oid;
	}
	
	public void setOid(String oid) {
		this.oid=oid;
	}
	
	public OrderNumber getOrderNumber() {
		return this.orderNumber;
	}
	
	public void setOrderNumber(OrderNumber orderNumber) {
		this.orderNumber=orderNumber;
	}
	
	public Date getDeliveryDate() {
		return this.deliveryDate;
	}
	
	public void setDeliveryDate(Date deliveryDate) {
		this.deliveryDate=deliveryDate;
	}
	
	public String getStoreId() {
		return this.storeId;
	}
	
	public void setStoreId(String storeId) {
		this.storeId=storeId;
	}
	
	public Date getPlacementDate() {
		return this.placementDate;
	}
	
	public void setPlacementDate(Date placementDate) {
		this.placementDate=placementDate;
	}
	
	public String getOrderState() {
		return this.orderState;
	}
	
	public void setOrderState(String orderState) {
		this.orderState=orderState;
	}
	
	public CustomerOrderView getCustomer() {
		return this.customer;
	}
	
	public void setCustomer(CustomerOrderView customer) {
		this.customer=customer;
	}
	
	public List<OrderItemQuantityView> getOrderItems() {
		return this.orderItems;
	}
	
	public void setOrderItems(List<OrderItemQuantityView> orderItems) {
		this.orderItems=orderItems;
	}
	
	public void addOrderItems(OrderItemQuantityView orderItems) {
		if (orderItems == null) {
			throw new IllegalArgumentException("parameter 'orderItems' must not be null");
		}
		if (getOrderItems() == null) {
			this.orderItems = new ArrayList<OrderItemQuantityView>();
		}
		this.orderItems.add(orderItems);
	}
	
	
	@Override
	public String toString() {
		StringBuilder toStringBuilder = new StringBuilder("OrderStateView [");
		toStringBuilder.append("maxOrderItemCount=").append(getMaxOrderItemCount()).append(",");
		toStringBuilder.append("oid=").append(getOid()).append(",");
		toStringBuilder.append("orderNumber=").append(getOrderNumber()).append(",");
		toStringBuilder.append("deliveryDate=").append(getDeliveryDate()).append(",");
		toStringBuilder.append("storeId=").append(getStoreId()).append(",");
		toStringBuilder.append("placementDate=").append(getPlacementDate()).append(",");
		toStringBuilder.append("orderState=").append(getOrderState());
		return toStringBuilder.append("]").toString();
	}
}
