package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import java.util.Date;
import org.openxma.dsl.platform.valueobject.ValueObjectByteArray;
import org.openxma.dsl.reference.types.valueobject.VOBigDecimal;
import org.openxma.dsl.reference.types.valueobject.VOBoolean;
import org.openxma.dsl.reference.types.valueobject.VOByteArray;
import org.openxma.dsl.reference.types.valueobject.VODate;
import org.openxma.dsl.reference.types.valueobject.VODouble;
import org.openxma.dsl.reference.types.valueobject.VOFloat;
import org.openxma.dsl.reference.types.valueobject.VOI18Enumeration;
import org.openxma.dsl.reference.types.valueobject.VOLong;
import org.openxma.dsl.reference.types.valueobject.VOString;
import org.openxma.dsl.reference.types.valueobject.VOTimestamp;
import org.openxma.dsl.reference.types.valueobject.VOXml;

public abstract class VODataViewGen implements Serializable {
	private static final long serialVersionUID = 816215225;
	protected String oid;
	protected Date version;
	protected VOBigDecimal pVOBigDecimal;
	protected VODate pVODate;
	protected VOTimestamp pVOTimestamp;
	protected VODouble pVODouble;
	protected VOFloat pVOFloat;
	protected VOLong pVOLong;
	protected VOString pVOString;
	protected VOBoolean pVOBoolean;
	protected VOI18Enumeration pVOI18Enumeration;
	protected VOByteArray pVOByteArray;
	protected VOXml pVOXml;
	protected ValueObjectByteArray pVOXml2;
	
	public String getOid() {
		return this.oid;
	}
	
	public void setOid(String oid) {
		this.oid=oid;
	}
	
	public Date getVersion() {
		return this.version;
	}
	
	public void setVersion(Date version) {
		this.version=version;
	}
	
	public VOBigDecimal getPVOBigDecimal() {
		return this.pVOBigDecimal;
	}
	
	public void setPVOBigDecimal(VOBigDecimal pVOBigDecimal) {
		this.pVOBigDecimal=pVOBigDecimal;
	}
	
	public VODate getPVODate() {
		return this.pVODate;
	}
	
	public void setPVODate(VODate pVODate) {
		this.pVODate=pVODate;
	}
	
	public VOTimestamp getPVOTimestamp() {
		return this.pVOTimestamp;
	}
	
	public void setPVOTimestamp(VOTimestamp pVOTimestamp) {
		this.pVOTimestamp=pVOTimestamp;
	}
	
	public VODouble getPVODouble() {
		return this.pVODouble;
	}
	
	public void setPVODouble(VODouble pVODouble) {
		this.pVODouble=pVODouble;
	}
	
	public VOFloat getPVOFloat() {
		return this.pVOFloat;
	}
	
	public void setPVOFloat(VOFloat pVOFloat) {
		this.pVOFloat=pVOFloat;
	}
	
	public VOLong getPVOLong() {
		return this.pVOLong;
	}
	
	public void setPVOLong(VOLong pVOLong) {
		this.pVOLong=pVOLong;
	}
	
	public VOString getPVOString() {
		return this.pVOString;
	}
	
	public void setPVOString(VOString pVOString) {
		this.pVOString=pVOString;
	}
	
	public VOBoolean getPVOBoolean() {
		return this.pVOBoolean;
	}
	
	public void setPVOBoolean(VOBoolean pVOBoolean) {
		this.pVOBoolean=pVOBoolean;
	}
	
	public VOI18Enumeration getPVOI18Enumeration() {
		return this.pVOI18Enumeration;
	}
	
	public void setPVOI18Enumeration(VOI18Enumeration pVOI18Enumeration) {
		this.pVOI18Enumeration=pVOI18Enumeration;
	}
	
	public VOByteArray getPVOByteArray() {
		return this.pVOByteArray;
	}
	
	public void setPVOByteArray(VOByteArray pVOByteArray) {
		this.pVOByteArray=pVOByteArray;
	}
	
	public VOXml getPVOXml() {
		return this.pVOXml;
	}
	
	public void setPVOXml(VOXml pVOXml) {
		this.pVOXml=pVOXml;
	}
	
	public ValueObjectByteArray getPVOXml2() {
		return this.pVOXml2;
	}
	
	public void setPVOXml2(ValueObjectByteArray pVOXml2) {
		this.pVOXml2=pVOXml2;
	}
	
	
	@Override
	public String toString() {
		StringBuilder toStringBuilder = new StringBuilder("VODataView [");
		toStringBuilder.append("oid=").append(getOid()).append(",");
		toStringBuilder.append("version=").append(getVersion()).append(",");
		toStringBuilder.append("pVOBigDecimal=").append(getPVOBigDecimal()).append(",");
		toStringBuilder.append("pVODate=").append(getPVODate()).append(",");
		toStringBuilder.append("pVOTimestamp=").append(getPVOTimestamp()).append(",");
		toStringBuilder.append("pVODouble=").append(getPVODouble()).append(",");
		toStringBuilder.append("pVOFloat=").append(getPVOFloat()).append(",");
		toStringBuilder.append("pVOLong=").append(getPVOLong()).append(",");
		toStringBuilder.append("pVOString=").append(getPVOString()).append(",");
		toStringBuilder.append("pVOBoolean=").append(getPVOBoolean()).append(",");
		toStringBuilder.append("pVOI18Enumeration=").append(getPVOI18Enumeration()).append(",");
		toStringBuilder.append("pVOByteArray=").append(getPVOByteArray()).append(",");
		toStringBuilder.append("pVOXml=").append(getPVOXml()).append(",");
		toStringBuilder.append("pVOXml2=").append(getPVOXml2());
		return toStringBuilder.append("]").toString();
	}
}
