package org.openxma.dsl.reference.dtoassembler.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dtoassembler.dao.ParentDao;
import org.openxma.dsl.reference.dtoassembler.model.Parent;
import org.openxma.dsl.reference.dtoassembler.model.impl.ParentImpl;
/**
 * @see ParentDao
 */
@SuppressWarnings("unused")
public abstract class ParentDaoGenImpl extends GenericDaoHibernateImpl<Parent,String> implements ParentDao {
	
	public ParentDaoGenImpl() {
		super(ParentImpl.class);
	}
	
	/**
	 * @param context the context for the object creation
	 * @return a transient instance of entity <code>Parent</code> with an already assigned identifier.
	 */
	public Parent createEntity(Object context) {
		return create();
	}
	
	public Parent create() 
	{
		Parent parent = createEntityInstance();
		parent.setOid(dataFieldMaxValueIncrementer.nextStringValue());
		return parent;
	}
	
	protected Mapper getNamedQueryMapper(String queryName) {
		return new ParentDaoQueryMapper();
	}
	
	protected class ParentDaoQueryMapper extends NamedQueryMapper {
		
	@SuppressWarnings("unchecked")
	public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
		return super.mapOne(sourceObject, targetObject);
	}
}
}
