package org.openxma.dsl.reference.dtoassembler.validation;

import org.openxma.dsl.reference.base.validation.BaseEntityValidator;
import org.openxma.dsl.reference.dtoassembler.model.Child;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class ChildGenValidator extends BaseEntityValidator {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return Child.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(Child child) {
		Errors errors = createErrors(child);
		super.validate(child,errors);
		validate(child,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		Child child = (Child) object;
		ValidationUtils.rejectIfEmpty(errors, "parent", "field.required");
	}
}
