package org.openxma.dsl.reference.jsr303.dto;

import java.io.Serializable;
import javax.validation.constraints.Size;
import org.openxma.dsl.platform.validation.constraints.NotEmpty;
import org.openxma.dsl.reference.jsr303.dto.Jsr303TestEntityView;
import org.openxma.dsl.reference.jsr303.validation.ValidJsr303TestEntityView;

@ValidJsr303TestEntityView
public abstract class Jsr303TestEntityViewGen implements Serializable {
	private static final long serialVersionUID = -868142963;
	@Size.List({
		@Size(max=10,message="{validation.Size.String.Jsr303TestEntityView.baseString}"),
		@Size(min=5,max=10,message="{validation.Size.String.Jsr303TestEntityView.baseString}")
	})
	protected String baseString;
	public interface IsStrConstraint1Enabled { }
	@Size.List({
		@Size(max=5,message="{validation.Size.String.Jsr303TestEntityView.str}"),
		@Size(min=3,max=10,groups=IsStrConstraint1Enabled.class,message="{validation.Size.String.Jsr303TestEntityView.str}")
	})
	@NotEmpty(message="{validation.NotEmpty.String.Jsr303TestEntityView.str}")
	protected String str;
	protected String category;
	
	public String getBaseString() {
		return this.baseString;
	}
	
	public void setBaseString(String baseString) {
		this.baseString=baseString;
	}
	
	public String getStr() {
		return this.str;
	}
	
	public void setStr(String str) {
		this.str=str;
	}
	
	public String getCategory() {
		return this.category;
	}
	
	public void setCategory(String category) {
		this.category=category;
	}
	
	
	@Override
	public String toString() {
		StringBuilder toStringBuilder = new StringBuilder("Jsr303TestEntityView [");
		toStringBuilder.append("baseString=").append(getBaseString()).append(",");
		toStringBuilder.append("str=").append(getStr()).append(",");
		toStringBuilder.append("category=").append(getCategory());
		return toStringBuilder.append("]").toString();
	}
}
