package org.openxma.dsl.reference.jsr303.model.impl;

import javax.validation.constraints.Size;
import org.openxma.dsl.platform.validation.constraints.NotEmpty;
import org.openxma.dsl.reference.jsr303.model.Jsr303TestEntity;
import org.openxma.dsl.reference.jsr303.model.impl.Jsr303BaseEntityImpl;
import org.openxma.dsl.reference.jsr303.validation.ValidJsr303TestEntity;

@ValidJsr303TestEntity
public abstract class Jsr303TestEntityGenImpl extends Jsr303BaseEntityImpl implements Jsr303TestEntity {
	public interface IsStrConstraint1Enabled { }
	@Size.List({
		@Size(max=5,message="{validation.Size.String.Jsr303TestEntity.str}"),
		@Size(min=3,max=10,groups=IsStrConstraint1Enabled.class,message="{validation.Size.String.Jsr303TestEntity.str}")
	})
	@NotEmpty(message="{validation.NotEmpty.String.Jsr303TestEntity.str}")
	protected String str;
	protected String category;
	
	public String getStr() {
		return this.str;
	}
	
	public void setStr(String str) {
		this.str = str;
	}
	
	public String getCategory() {
		return this.category;
	}
	
	public void setCategory(String category) {
		this.category = category;
	}

	@Override
	public String toString() {
		StringBuilder toStringBuilder = new StringBuilder("Jsr303TestEntity [");
		toStringBuilder.append(super.toString()).append(",");
		toStringBuilder.append("str=").append(getStr()).append(",");
		toStringBuilder.append("category=").append(getCategory());
		return toStringBuilder.append("]").toString();
	}
}
