package org.openxma.dsl.reference.model;

import java.util.Date;
import java.util.Set;
import org.openxma.dsl.reference.base.model.BaseEntity;
import org.openxma.dsl.reference.model.Address;
import org.openxma.dsl.reference.model.Order;
import org.openxma.dsl.reference.types.Gender;
import org.openxma.dsl.reference.types.valueobject.TelefonNumber;

/**
 *  Customer Entity
 */
public interface CustomerGen extends BaseEntity  {

	String getFirstName();
	void setFirstName(String firstName);

	String getLastName();
	void setLastName(String lastName);

	Gender getGender();
	void setGender(Gender gender);

	String getEmailAddress();
	void setEmailAddress(String emailAddress);

	Date getBirthDate();
	void setBirthDate(Date birthDate);

	TelefonNumber getTelefonNumber();
	void setTelefonNumber(TelefonNumber telefonNumber);

	Date getLastOrderDate();

	Address getInvoiceAddress();
	void setInvoiceAddress(Address invoiceAddress);

	Address getDeliveryAddress();
	void setDeliveryAddress(Address deliveryAddress);

	Set<Order> getOrders();
	boolean hasOrders();
	void addOrders(Order orders);
	void removeOrders(Order orders);
	void removeAllOrders();
}
