package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VOInteger</code>.
 */
public class VOInteger extends org.openxma.dsl.platform.valueobject.ValueObjectInteger {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VOInteger(Integer pInteger) {
    	super(pInteger);
    }

    /**
     * Create a new instance of VOInteger or return null depending on input.
     */
    public static VOInteger newOrNull(Integer pInteger) {
        if (pInteger != null) {
            return new VOInteger(pInteger);
        }
        return null;
    }

/**
 * Create a new instance of VOInteger or return null depending on input.
 */
public static VOInteger newOrNull(String value) {
    if (value != null && value.length() > 0) {
        return new VOInteger(Integer.valueOf(value));
    }
    return null;
}

}
