package org.openxma.dsl.reference.ui.browsemodes.server;

import java.util.Locale;
import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.list.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;
import at.spardat.xma.rpc.RemoteCall;
import at.spardat.xma.rpc.RemoteReply;

/**
 * This class implements the generic server part of BrowseModesPage.
 * It implements the models of the page.
 *
 */
public abstract class BrowseModesPageGen extends PageServer {
    ISimpleWM editModeCheckBox;
    ISimpleWM tx1;
    IListWM cb1;
    ISimpleWM customer1_firstName;
    ISimpleWM customer1_birthDate;
    IListDomWM customer1_gender;
    ISimpleWM tx2;
    IListWM cb2;
    ISimpleWM customer2_firstName;
    ISimpleWM customer2_birthDate;
    IListDomWM customer2_gender;
    ISimpleWM tx3;
    IListWM cb3;
    ISimpleWM customer3_firstName;
    ISimpleWM customer3_birthDate;
    IListDomWM customer3_gender;
    WModel[] widgetModels;


    /**
     * Constructs the BrowseModesPageGen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public BrowseModesPageGen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        IFmt formatter;
        CompoundValidator compound;
        editModeCheckBox = new SimpleWM((short) 0, Types.T_BOOLEAN, this);
        tx1 = new SimpleWM((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx1.setFmt(formatter);
        cb1 = new ListWM((short) 2,this, ListWM.S_NULL);
        customer1_firstName = new SimpleWM((short) 3, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer1_firstName.setFmt(formatter);
        customer1_firstName.setMandatory(true);
        customer1_birthDate = new SimpleWM((short) 4, Types.T_DATE, this);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        compound = new CompoundValidator(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        compound.setFormatter(formatter);
        formatter = compound;
        customer1_birthDate.setFmt(formatter);
        customer1_birthDate.setMandatory(true);
        customer1_gender = new ListDomWM((short) 5,this, "type=rsc,bundle=org.openxma.dsl.reference.types.Gender");
        customer1_gender.setMandatory(true);
        tx2 = new SimpleWM((short) 6, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx2.setFmt(formatter);
        cb2 = new ListWM((short) 7,this, ListWM.S_NULL);
        customer2_firstName = new SimpleWM((short) 8, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer2_firstName.setFmt(formatter);
        customer2_firstName.setMandatory(true);
        customer2_birthDate = new SimpleWM((short) 9, Types.T_DATE, this);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        compound = new CompoundValidator(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        compound.setFormatter(formatter);
        formatter = compound;
        customer2_birthDate.setFmt(formatter);
        customer2_birthDate.setMandatory(true);
        customer2_gender = new ListDomWM((short) 10,this, "type=rsc,bundle=org.openxma.dsl.reference.types.Gender");
        customer2_gender.setMandatory(true);
        tx3 = new SimpleWM((short) 11, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx3.setFmt(formatter);
        cb3 = new ListWM((short) 12,this, ListWM.S_NULL);
        customer3_firstName = new SimpleWM((short) 13, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer3_firstName.setFmt(formatter);
        customer3_firstName.setMandatory(true);
        customer3_birthDate = new SimpleWM((short) 14, Types.T_DATE, this);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        compound = new CompoundValidator(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        compound.setFormatter(formatter);
        formatter = compound;
        customer3_birthDate.setFmt(formatter);
        customer3_birthDate.setMandatory(true);
        customer3_gender = new ListDomWM((short) 15,this, "type=rsc,bundle=org.openxma.dsl.reference.types.Gender");
        customer3_gender.setMandatory(true);

        widgetModels = new WModel[] { (WModel) editModeCheckBox, (WModel) tx1, (WModel) cb1, (WModel) customer1_firstName, (WModel) customer1_birthDate, (WModel) customer1_gender, (WModel) tx2, (WModel) cb2, (WModel) customer2_firstName, (WModel) customer2_birthDate, (WModel) customer2_gender, (WModel) tx3, (WModel) cb3, (WModel) customer3_firstName, (WModel) customer3_birthDate, (WModel) customer3_gender };
    }

    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        return getSession().getContext().getLocale();
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return BrowseModes.BrowseModesPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public BrowseModes getTypedComponent() {
        return (BrowseModes) getComponent();
    }

    /**
     * Copies values of all attached widget models to attributes of the BusinessData instance variables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void modelToInstanceData() {
        atomicWMToBusinessData(getTypedComponent().getCustomer1(), getTypedComponent().getCustomer2(), getTypedComponent().getCustomer3());
    }

    /**
     * Copies attribute values of the BusinessData instance variables into their attached widget models.
     * This includes simple widget models and tables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void instanceDataToModel() {
        businessDataToAtomicWM(getTypedComponent().getCustomer1(), getTypedComponent().getCustomer2(), getTypedComponent().getCustomer3());
    }

    /**
     * Copies values of widget models to attributes of the provided BusinessData objects.
     */
    public void atomicWMToBusinessData(org.openxma.dsl.reference.dto.CustomerView customer1, org.openxma.dsl.reference.dto.CustomerView customer2, org.openxma.dsl.reference.dto.CustomerView customer3) {
        customer1.setFirstName(customer1_firstName.toString());
        customer1.setBirthDate(customer1_birthDate.toDate());
        customer1.setGender(customer1_gender.getSelected() != null ? org.openxma.dsl.reference.types.Gender.valueOfKey(customer1_gender.getSelected()) : null);
        customer2.setFirstName(customer2_firstName.toString());
        customer2.setBirthDate(customer2_birthDate.toDate());
        customer2.setGender(customer2_gender.getSelected() != null ? org.openxma.dsl.reference.types.Gender.valueOfKey(customer2_gender.getSelected()) : null);
        customer3.setFirstName(customer3_firstName.toString());
        customer3.setBirthDate(customer3_birthDate.toDate());
        customer3.setGender(customer3_gender.getSelected() != null ? org.openxma.dsl.reference.types.Gender.valueOfKey(customer3_gender.getSelected()) : null);
    }

    /**
     * Copies attribute values of the provided BusinessDatas into widget models.
     */
    public void businessDataToAtomicWM(org.openxma.dsl.reference.dto.CustomerView customer1, org.openxma.dsl.reference.dto.CustomerView customer2, org.openxma.dsl.reference.dto.CustomerView customer3) {
        customer1_firstName.set(customer1.getFirstName());
        customer1_birthDate.set(customer1.getBirthDate());
        customer1_gender.set(customer1.getGender() != null ? customer1.getGender().getKey() : null);
        customer2_firstName.set(customer2.getFirstName());
        customer2_birthDate.set(customer2.getBirthDate());
        customer2_gender.set(customer2.getGender() != null ? customer2.getGender().getKey() : null);
        customer3_firstName.set(customer3.getFirstName());
        customer3_birthDate.set(customer3.getBirthDate());
        customer3_gender.set(customer3.getGender() != null ? customer3.getGender().getKey() : null);
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

    abstract public void load(RemoteCall call, RemoteReply reply);
}
