package org.openxma.dsl.reference.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.openxma.dsl.reference.model.Bug;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class BugGenValidator extends Validators {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return Bug.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(Bug bug) {
		Errors errors = createErrors(bug);
		validate(bug,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		Bug bug = (Bug) object;
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "bugId", "field.required");
	}
}
