package org.openxma.dsl.reference.validation;

import org.openxma.dsl.reference.base.validation.BaseEntityValidator;
import org.openxma.dsl.reference.model.Order;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class OrderGenValidator extends BaseEntityValidator {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return Order.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(Order order) {
		Errors errors = createErrors(order);
		super.validate(order,errors);
		validate(order,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		Order order = (Order) object;
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "orderNumber", "field.required");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "storeId", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "placementDate", "field.required");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "orderState", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "totalAmount", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "customer", "field.required");
		rejectIfMaxLength(errors,"orderState",order.getOrderState(),33);
	}
}
