package org.openxma.dsl.reference.validation;

import org.openxma.dsl.reference.model.PrivateCustomer;
import org.openxma.dsl.reference.validation.CustomerValidator;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class PrivateCustomerGenValidator extends CustomerValidator {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return PrivateCustomer.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(PrivateCustomer privateCustomer) {
		Errors errors = createErrors(privateCustomer);
		super.validate(privateCustomer,errors);
		validate(privateCustomer,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		PrivateCustomer privateCustomer = (PrivateCustomer) object;
		ValidationUtils.rejectIfEmpty(errors, "ccInfo", "field.required");
	}
}
