package org.openxma.dsl.reference.validation;

import org.openxma.dsl.reference.base.validation.BaseEntityValidator;
import org.openxma.dsl.reference.model.ProductImage;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class ProductImageGenValidator extends BaseEntityValidator {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return ProductImage.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(ProductImage productImage) {
		Errors errors = createErrors(productImage);
		super.validate(productImage,errors);
		validate(productImage,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		ProductImage productImage = (ProductImage) object;
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "field.required");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "fileName", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "product", "field.required");
	}
}
